
<h1>Watchlist</h1>

<% if @quote %>
    <%= render :partial=>'asset/quote_form', locals: { :quote=>@quote, :securities=>@securities  } %>
<% end %>

<%= search_form_for @watchlist.query, :url=>{:controller=>:watchlist, :action=>:index}, :class=>'filter_form, watchlist_filter', :id=>:controller_filter do |f| %>
<div>
    <%= f.search_field :symbol_or_brief_or_Organization_name_cont_any, :placeholder=>'Pattern' %>
    <%= f.submit :filter %>

 <table>
    <tr><th colspan="2">Generic Filters</th></tr>
    <tr><td><%= check_box_tag :exclude_securities, true, @opt_exclude_securities %></td><td><%= f.label :exclude_held_securities %></td></tr>

    <tr><td><%= check_box_tag :provides_collateral, true, @opt_provides_collateral %></td><td><%= f.label :provides_collateral %></td></tr>

    <tr><td><%= check_box_tag :provides_cashflow, true, @opt_provides_cashflow %></td><td><%= f.label :provides_cashflow_this_year %></td></tr>

    <tr><td><%= check_box_tag :provides_huge_coupon, true, @opt_provides_huge_coupon %></td><td><%= f.label :provides_huge_coupon %></td></tr>

    <tr><td><%= check_box_tag :provides_subannual_payments, true, @opt_provides_subannual_payments %></td><td><%= f.label :provides_subannual_payments %></td></tr>

    <tr><td><%= check_box_tag :matures_within_year, true, @opt_matures_within_year %></td><td><%= f.label :matures_within_year %></td></tr>

    <tr><th colspan="2">Type of Security</th></tr>
    <% Security.types.each do |t|
       type_id_column = ('id_security_%s_gt' % t).to_sym
       %>
       <tr><td><%= check_box_tag 'q[%s]' % type_id_column,
              0,
              (if params[:q] and params[:q][type_id_column] then true else false end)
       %></td><td>
       <%= label_tag 'q[%s][]' % type_id_column, Security.describe_type(t) %></td></tr>
    <% end %>

    <tr><th colspan="2">Bond Properties</th></tr>
    <% SecurityBond.types.each do |t| %>
       <tr><td><%= check_box_tag 'q[SecurityBond_type_eq_any][]',
              t.second,
              (if params[:q] and params[:q][:SecurityBond_type_eq_any] and params[:q][:SecurityBond_type_eq_any].include?(t.second.to_s) then true else false end)
       %></td><td>
       <%= label_tag 'q[SecurityBond_type_eq_any][]', SecurityBond.describe_type(t.first) %></td></tr>
    <% end %>

    <tr><th colspan="2">Stock Properties</th></tr>
    <% SecurityStock.types.each do |t| %>
       <tr><td><%= check_box_tag 'q[SecurityStock_type_eq_any][]',
              t.second,
              (if params[:q] and params[:q][:SecurityStock_type_eq_any] and params[:q][:SecurityStock_type_eq_any].include?(t.second.to_s) then true else false end)
       %></td><td>
       <%= label_tag 'q[SecurityStock_type_eq_any][]', SecurityStock.describe_type(t.first) %></td></tr>
    <% end %>
 </table>
</div>
<% end %>

<div id='watchlist_overview' class="overview_counters">
  <ul>
    <li>Items Found: <span><%= @watchlist.count %></span></li>
  </ul>
</div>

<table id='watchlist'>
  <thead>
    <tr>
    </tr>
    <tr>
        <th></th>
        <th>Exchange</th>
        <th>Low / High</th>
        <th>Volume</th>
        <th>Last Trade</th>
        <th><%= sort_link @watchlist.query, :current_yield, 'CY', default_order: :desc %></th>
        <th><%= sort_link @watchlist.query, :yield_to_maturity, 'YTM', default_order: :desc %></th>
        <th><%= sort_link @watchlist.query, :yield_to_call, 'YTC', default_order: :desc %></th>
        <th><%= sort_link @watchlist.query, :cashflow_this_year, 'Cashflow this Year', default_order: :desc %></th>
        <th><%= sort_link @watchlist.query, :collateral_coverage_ratio, 'Collateral Provided', default_order: :desc %></th>
    </tr>
  </thead>
  <tbody>
  <% @watchlist.each do |i| %>
    <tr class="separaterows">
      <td>
        <%= link_to '+', watchlist_index_path(:intraday_data=>i.id, :anchor=>"watchlist_id#{i.id}"), :id=>"watchlist_id#{i.id}" %>
        <%= link_to '...', i.security.link.to_url %>
        <%= i.security %>
        <span class="symbol"><%=i.security.symbol%></span>
      </td>
      <td><%= i.quote.exchange %></td>
          <td>
            <% if i.quote.low or i.quote.high %>
                <%= smr_humanize(i.quote.low) %> / <%= smr_humanize(i.quote.high) %>
            <% end %>
          </td>
      <td><%= smr_humanize(i.quote.volume, :shortword=>true)%></td>
      <td><%= smr_humanize i.quote.last %> <span class="<%= i.quote.css_class(smr_browse_date(:keep_current_time=>true), :intraday=>true) %>">&bull;</span></td>
      <td><%= smr_humanize(i.security.current_yield(i.quote), :scale=>2)%></td>
      <td><%= smr_humanize(i.security.yield_to_maturity(i.quote), :scale=>2)%></td>
      <td><%= smr_humanize(i.security.yield_to_call(i.quote), :scale=>2)%></td>
      <td><%= smr_humanize(i.security.cashflow_this_year smr_browse_date)%></td>
      <td><%= smr_humanize i.security.collateral_coverage_ratio %></td>
    </tr>
   <% if @have_intraday_data == i.id %>
     <%
      _have_shown_cashflow = false
      @intraday_data.each do |q| %>
       <tr class="have_intraday_data">
          <td><%= smr_humanize(q.time, :date_time_only=>true) %></td>
          <td><%= q.exchange %></td>
          <td>
            <% if q.low or q.high %>
                <%= smr_humanize(q.low) %> / <%= smr_humanize(q.high) %>
            <% end %>
          </td>
          <td><%= smr_humanize q.volume, :shortword=>true %></td>
          <td><%= smr_humanize q.last %>&nbsp;&nbsp;</td>
          <td><%= smr_humanize i.security.current_yield(q), :scale=>2 %></td>
          <td><%= smr_humanize i.security.yield_to_maturity(q),:scale=>2 %></td>
        <% unless _have_shown_cashflow %>
          <td rowspan="<%= @intraday_data.count  %>">
            <div class="overview_container">
            <table id="overview_cashflow">
             <tbody>
              <% i.security.cashflow(:start_date=>smr_browse_date).each  do |c| %>
                <tr>
                    <td><%= smr_humanize c.date %></td>
                    <td><%= smr_humanize c.total, :scale=>2 %>
                       <% unless [0, 1.0].include? c.poolfactor %><span>pf=<%= smr_humanize c.poolfactor, :scale=>3 %></span><% end %>
                    </td>
                </tr>
              <% _have_shown_cashflow = true
               end %>
             </tbody>
            </table>
            </div>
          </td>
        <% end %>
       </tr>
     <% end %>
   <% end %>
  <% end %>
  </tbody>
</table>
